<template>
  <div class="content">
    <header>
      <GoBackButton :target="this.$route.params.user" />
      <h1 class="text-center">Questionario</h1>
    </header>

    <section class="container faq">
      <div class="row no-gutters" v-for="(item, index) in flow" :key="index" :class="{ 'question': index % 2 === 0, 'answer': index % 2 !== 0 }">
        <div>
          {{ item.message }}
        </div>
      </div>
      <p v-if="disableOption">
        Fim do atendimento
      </p>
    </section>

    <section class="action" v-if="!disableOption">
      <div class="row no-gutters text-center">
        <template v-if="questions[currentQuestion].options.type === 'array'">
          <div class="col-6" v-for="option in questions[currentQuestion].options.data" :key="option.value">
            <span @click="answer(option)">{{ option.display }}</span>
          </div>
        </template>
        <template v-if="questions[currentQuestion].options.type === 'input'">
          <div class="col-6 pl-2 pr-2">
            <input class="form-control" type="text" v-model="questions[currentQuestion].options.data">
          </div>
          <div class="col-6">
            <span @click="answer(questions[currentQuestion].options.data)">Enviar</span>
          </div>
        </template>
      </div>
    </section>
  </div>
</template>

<script>
export default {
  mounted() {
    this.pushQuestion();
  },

  methods: {
    pushQuestion() {
      this.flow.push({message: this.questions[this.currentQuestion].question});
    },

    answer(option) {
      if (!option) {
        return;
      }

      if (typeof option == 'object') {
        this.flow.push({message: option.display});
      }

      if (typeof option == 'string') {
        this.flow.push({message: this.questions[this.currentQuestion].options.data});
      }

      console.log('typeof', typeof option);
      console.log('this.currentQuestion', this.currentQuestion)
      console.log('this.questions.length', this.questions.length);
      if (this.currentQuestion === this.questions.length - 1) {
        this.disableOption = true;
        return;
      }

      this.currentQuestion = this.currentQuestion + 1;
      this.pushQuestion();
    },
  },

  data() {
    return {
      disableOption: false,
      flow: [
      ],

      currentQuestion: 0,
      questions: [
        {
          question: 'Em que posso ajudar?',
          options: {
            type: 'array',
            data: [
              {
                value: 'febre',
                display: 'Febre'
              },
            ],
          },
        },

        {
          question: 'Qual a idade do paciente?',
          options: {
            type: 'input',
            data: '',
          },
        },

        {
          question: 'Qual o peso do paciente?',
          options: {
            type: 'input',
            data: '',
          },
        },

        {
          question: 'Qual o temperatura do paciente?',
          options: {
            type: 'input',
            data: '',
          },
        },

        {
          question: 'Esse questionario não tem uma conclusão, pois não foi possivel entrar em contato com o pediatra.',
          options: {
            type: 'array',
            data: [
              {
                value: 'ok',
                display: "Ok"
              }
            ],
          },
        },
      ],
    };
  },
}
</script>

<style scoped>
  .content {
    margin-bottom: calc(2rem + 40px);
  }

  .question {
    justify-content: flex-start;
    color: #68B2A0;
  }

  .answer {
    justify-content: flex-end;
  }

  .answer > div,
  .question > div {
    padding: 11px 22px;
    border-radius: 8px;
    box-shadow: 0 3px 6px 0 hsla(0, 0%, 0%, 0.2);
    margin: .5rem 0;
  }

  .answer > div {
    background-color: #329D9C;
    color: #fff;
  }

  .action {
    width: 100%;
    position: fixed;
    bottom: 12px;
  }

  .action .row span {
    cursor: pointer;
    width: 80%;
    display: inline-block;
    padding: .5rem 2rem;
    background-color: #39A49B;
    color: #fff;
    font-weight: bold;
    border-radius: 12px;
    margin: 0;
    box-shadow: 0 3px 6px 0 hsla(0, 0%, 0%, 0.2);
  }
</style>
